<script setup>
import AppShare from '@/helpers/AppShare'
import { useDialogStore } from '@/stores/DialogStore'
</script>


<script>
export default {

	data() {
		return {
			email: '',
			password: '',
			confirmPassword: '',
		}
	},

	methods: {
		async onSubmit() {
			const dialogStore = useDialogStore()

			if (this.password !== this.confirmPassword) {
				dialogStore.warningBox(this.$t('validator.isSamePasswords'))
				return
			}

			const result = await dialogStore.waitBox(async () =>
				await AppShare.client.call(`members/signup`, {
					method: 'POST',
					headers: AppShare.client.defaultHeaders(),
					data: {
						member: {
							email: this.email,
							password: this.password,
							confirmPassword: this.confirmPassword,
							locale: this.$i18n.locale,
						},
					},
				})
			)
			if (!dialogStore.handleRestError(result)) {
				dialogStore.infoBox(this.$t('confirm'))
				this.$router.go(-1)
			}
		}
	},

	i18n: {
		messages: {
			en: {
				title: "Sign Up",
				email: "Email",
				password: "Password",
				confirmPassword: "Confirm Password",
				ok: "Register",
				confirm: "Please confirm the sign-up by email!",
			},
			th: {
				title: "สมัครสมาชิก",
				email: "อีเมล",
				password: "รหัสผ่าน",
				confirmPassword: "ยืนยันรหัสผ่าน",
				ok: "ลงทะเบียน",
				confirm: "โปรดยืนยันการสมัครสมาชิกทางอีเมล!",
			},
		},
	},
}
</script>


<template>
	<AppBox :title="$t('title')">
		<form id="form" @submit.prevent="onSubmit">
			<!-- email -->
			<label for="email">{{ $t('email') }}</label><br />
			<input id="email" type="email" :placeholder="$t('email')" required v-model="email" /><br />
			<br />

			<!-- password -->
			<label for="password">{{ $t('password') }}</label><br />
			<input id="password" type="password" :placeholder="$t('password')" required minlength="4" maxlength="20"
				v-model="password" /><br />
			<br />

			<!-- confirm password -->
			<label for="confirmPassword">{{ $t('confirmPassword') }}</label><br />
			<input id="confirmPassword" type="password" :placeholder="$t('confirmPassword')" required minlength="4"
				maxlength="20" v-model="confirmPassword" /><br />
			<br />

			<button type="submit">{{ $t('ok') }}</button>
		</form>
	</AppBox>
</template>


<style scoped>
</style>
